;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read LICENSE file for full copyright information (GNU GPL)
;-
;-  file  	: template.asm
;-  created	: 08-sep-00
;-  modified	:
;-  version	; 0.01, "lib4th" 0.0.34+ (re "version.inc")
%include "version.inc"
;-  assembler	: nasm 0.98-3e (patched & bugs fixed 0.98)
;-  description	: lib4th application assembly template
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-================================================================;
;-

;- %define __DBG	; enable debugging macroes & subroutines, further, 
;- %define __MK_DBG	; __MK_DBG required set for those being activated,
;-			; which adds about 1,3K to the binary.
;- %undef __LIB4TH	; this mustn't be defined unless in library source!
%undef __LIB4TH
%undef __DBG
%undef __MK_DBG
;-
;-
;- %includes for application programs
;-		required:
;-	%include "system.inc"	; asmutils: system calls, linux refs
;-	%include "constants.inc";\ lib4th
;-	%include "lib4th.mac"	;/ specific 
;-	%include "version.inc"	; library version
;-		optional:
;-	%include "limits.h.inc" ; files, buffers, etc.
;-	%include "termbits.inc"	; terminal
;-	%include "fcntl.inc"	; i/o mode
;-	%include "vt.inc"	; vt struc's
;-	%include "reloc.inc"	; for <kernref>
;-	%include "errno.inc"	; error messages
;-	%include "pushpop.mac"	; stack ref
;-	%include "ascictrl.inc"	; ascii names of ctrls
;-	%include "debug.inc"	; debugging macros
; ------------- ;
%include "system.inc"
%ifndef termbitsinc
%include "termbits.inc"	;
%endif
%ifndef fcntlinc
%include "fcntl.inc"	; i/o mode
%endif
%ifndef vtinc
%include "vt.inc"	; vt struc's
%endif
%ifndef relocinc
%include "reloc.inc"	; for <kernref>
%endif
%ifndef constantsinc
%include "constants.inc"
%endif
%ifndef lib4thinc
%include "lib4th.mac"
%endif
%ifndef errnoinc
%include "errno.inc"	; error messages
%endif
%ifndef pushpopinc
%include "pushpop.mac"	; (sic)
%endif
%ifndef ascictrlinc
%include "ascictrl.inc"
%endif
%ifndef debuginc
%include "debug.inc"	; debugging macros
%endif

%ifndef __MK_DBG
%undef __DBG
%endif
;

;-================================================================
    section .text
;- kernel code & constant data
;-	
;-
;- Q
;-	label, 1st(!) address in .text
Q:equ $$

;
;-================================================================
;- debugging
;-

%ifdef __DBG
;- dbg		beginning of debugging routines
dbg:
	mdump
	perrm
	perrs
	perrn
	dbmrg
%define __DBCONS
	dbcons
	pbits	; flagbits/binary
	psbits	; eflags symbols
%endif;__DBG

;-
;- debugging routines end
;-================================================================
;-

; ================================================================

;not required (300 bytes):
;    extern Vroot,Croot,Lroot,roottop,toplink,topref,vocref
;    extern Vforth,Cforth,Lforth

;-
; text constants
;-
;-================================================================
;- (ref's to) signals constants and error messages, jumptables
;- by macros <ertstg>, <ertdsp>, <sigstg>, <sigdsp>
;-
	a
    ertstg 1	; compiles just the 'extern' refs, valid also for <ertdsp>
	a
    ertdsp
	a
    sigstg 1	; compiles just the 'extern' refs, valid also for <sigdsp>
	a
    sigdsp
;-
;-================================================================
;- START4TH macro initiates library utilisation
;-	and continues with program execution
;-
START4TH 0,continue,vquit,{10,"This is 'lib4th-",.vers,"' Asm Template #3"};:ok:
;-    
;-	INSERT RUNNING PROGRAM CODE HERE
;-	most simple start would be just a jmp into lib4th {quit}
iniquit:
    jmpx quit
;-
;-	any other prog/data stuff might follow
;-
    a
vquit:	;struc i4th, defaults
.ntry:
    dd 0; or true address of code enty, e.g.: dd iniquit
.dstack:
    dd d_dstack
.rstack:
    dd d_rstack
.tibmem:
    dd d_ntib
.uarea:	; minimal value is 64K!
    dd d_uarea
.cplmem:
    dd d_dictionary
.datamem:
    dd d_varispace
.e:
    dd -1
;-
;-================================================================
;- END4TH, optional macro marks end of program area,
;-	  <kend> is final .text label, immediately before .bss begins
END4TH
;-
;-================================================================
;- template.asm <eof>
